// @ myth - client - status.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef STATUS_HEADER
#define STATUS_HEADER

// @@ include

#include "client/window.h"
#include "common/command.h"

// @@ class STATUS

class STATUS : WINDOW
{
    status_value status[STATUS_END];	// Current value for each status.
    int from;			// First status show on screen.
    bool touched;		// Any reason to update window?
public:
    void set(status_type type, status_value value = TRUE);
    inline void clear(status_type type)
    { set(type, FALSE); }
    void show(int arg = 0);
    void update();
    inline bool playing()
    { return status[STATUS_GAME] < GAME_OVER; }
    STATUS();
};

// @@ end

#endif STATUS_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
