// @ myth - server - bunch.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef BUNCH_HEADER
#define BUNCH_HEADER

// @@ include

#include "server/invent.h"

// @@ BUNCH

class BUNCH : public INVENTORY
{
    char MonsterLook;
public:
    // Monster want to use the stairs
    void MoveUp(LEVEL* level, MONSTER* monster);
    void MoveDown(LEVEL* level, MONSTER* monster);
    // Monster want to enter or leave the bunch
    bool AcceptEnter(MONSTER* monster);
    bool AcceptLeave(MONSTER* monster);
    QUESTION* GetQuestion(PLAYER* player, LEVEL* level, coor pos);
    void defend(MONSTER* monster, LEVEL* level);
    // MISC
    void update(LEVEL* level, coor pos, MONSTER* monster);
    bool blocking()		// TRUE, iff bunch block the view
    { return size() > 10000L; }
    char detect()		// The char seen on monster detection
    { return MonsterLook; }
    void describe(rock_type rock, PLAYER* player); // Describe loc. to player
    OBJECT* HitOne();		// Select an object to be hit in the bunch
    BUNCH() { }
    BUNCH(PARSE* parse, coor pos) : (parse, pos) { }
};

// @@ end

#endif BUNCH_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
