// @ myth - server - global.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef GLOBAL_HEADER
#define GLOBAL_HEADER

// @@ include

#include "common/page.h"

// @@ enum level_type

enum level_type
{
    LEVEL_EXIT,			//  0 -- outside the dungeon (escaped!)
    LEVEL_HOME,			//  1 -- start level
    LEVEL_HELL,			//  2 -- some deep level
				//  3.. -- other levels in the dungeon
    LEVEL_ERROR = ERROR,	// -1 -- invalid value
    LEVEL_REMOVE = -2,		// -2 -- remove monster from game
};

// @@ GLOBAL

class GLOBAL
{
    PAGE CaveNames;		// Names of each cave
    long ShutDownTime;		// Numbver seconds without player allowed
    bool MyEmergency;		// Got a SIGHUP yet?
public:
    // Create filenames here
    //
    STRING DungeonFile();
    STRING CaveBinaryFile(level_type type);
    STRING CaveTextFile(level_type type);
    //
    // Handle the dungeon
    //
    inline int DungeonSize()
    { return CaveNames.length(); }
    level_type CaveToLevel(STRING name);
    STRING LevelToCave(level_type depth);
    //
    // Misc
    //
    inline long TimeOut()
    { return ShutDownTime; }
    inline void SetEmergency()
    { MyEmergency = TRUE; }
    inline bool emergency()	// Got a SIGHUP?
    { return MyEmergency; }
    //
    // Administration
    //
    void load(int argc, char** argv);
    GLOBAL();
};

extern GLOBAL global;

// @@ end

#endif GLOBAL_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
